import $ from "./jquery.module.js";

let inset = 0;

function setInset (newInset) {
    inset = newInset;
}

function rectsOverlap(domRect1, domRect2, infinite_height = false)
{
    // console.log(domRect1, domRect2);
    // If one rectangle is on left side of other
    if (domRect1.left > domRect2.right - inset || domRect2.left > domRect1.right - inset) {
        return false;
    }

    if (infinite_height)
        return true;

    // If one rectangle is above other
    if (domRect1.top > domRect2.bottom - inset || domRect2.top > domRect1.bottom - inset) {
        return false;
    }

    return true;
}

function testCollisionForElements(el1, el2) {
    return rectsOverlap(el1.getBoundingClientRect(), el2.getBoundingClientRect());
}

function testCollisionForJQueryElements($el1, $el2) {
    return testCollisionForElements($el1[0], $el2[0]);
}

function testCollisionForAllJQueryElements($el1, $elAll) {
    const rect = $el1[0].getBoundingClientRect();
    let foundCollision = false;
    let collider = null;

    $elAll.each((i, element) => {
        let obsRect = element.getBoundingClientRect();
        if (rectsOverlap(rect, obsRect)) { // Guarantee we will collide if it is a goal object
            // console.log("Found collision");
            foundCollision = true;
            collider = $(element);
            return {foundCollision, collider};
        }
    });

    return {foundCollision, collider};
}

export {testCollisionForElements, testCollisionForJQueryElements, testCollisionForAllJQueryElements, setInset};