import $ from "./jquery.module.js";
import * as audio from "./audio.js";
import {pause} from "./audio.js";
import SetConfig from "./set_config_class.js";
import {getMathProblemGenerator} from "./math_operation_problems.js";

let setConfigHandler = new SetConfig();

function setConfig(config) {
    setConfigHandler.setConfig(config);
}

$(async function () {

    let config = await setConfigHandler.configPromise;
    let options = config.options;

    /* THINGS TO BE SET IN CONFIG FILE */
    let $wrapper = $("#wrapper");
    $wrapper.css("backgroundImage", `url(${options.backgroundImage})`);

    let minimum = options.minimum; // Minimum numbers in problem ;
    let maximum = options.maximum; // Maximum  numbers in problem ;
    let num_problems = options.num_problems;  // Number of problems to show ;
    let decimals = options.decimals; // Change to allow a given number of decimal places in answer ;
    let completionURL;
    let operation = options.operation; // 1= multiply, 2 = divide, 3= add, 4= subtract ;

    let problem = getMathProblemGenerator(config.mathProblem);


    /* End of config file things   */

    let answers = 0;
    let rightAnswer;
    let pet = document.getElementById("pet");
    let numwrong = 0; // Really only needed if writing to a database;


// Messages shown when you get an answer correct ;
    const sources = config.sources;

    // SECTION TO CREATE PROBLEMS ;
    function getProb() {
        $('#formx').addClass("d-none");
        $("#message_text").addClass("d-none");
        $("#next").addClass("d-none");
        document.math.answer.value = "";
        let quizText = problem.getProblem();
        $("#firstN").html(`<strong>${quizText}</strong>`);
        rightAnswer = problem.correctAnswer;
        $('#mathform').removeClass("d-none");
        $("#answer").focus();
        $('#theAnswer').addClass("d-none");
        pause();
    }

    /* SECTION TO SCORE MATH PROBLEMS  */

    function answerit() {
        //  BlurActiveElement();
        let $answer = $("#answer");
        let theirAnswer = $answer.val();
        let wrongans = document.getElementById('theAnswer');
        $("#rightAnswer").text(rightAnswer);
        $("#theirAnswer").text(theirAnswer);
        if (theirAnswer == null) {
            $('#nullans').removeClass("d-none");
            window.setTimeout(function () {
                $('#nullans').addClass("d-none");
            }, 3000);
            document.math.answer.select();
            //  WHAT HAPPENS IF THE ANSWER IS CORRECT - THEY GET A DOG / DOG THING ;
        } else {
            if (theirAnswer === rightAnswer) {
                $('#mathform').addClass("d-none");
                answers++;
                $("#message_text").text(sources[answers][0]).removeClass("d-none");
                pet.src = sources[answers][1];
                $("#formx").removeClass('d-none');

                playGame();

            } else {
                $('#mathform').addClass("d-none");
                numwrong++;
                $('#wrong').removeClass("d-none");
                $('#wrong-dog-howl').get(0).currentTime = 0; // rewind
                $('#wrong-dog-howl').get(0).play();

                setTimeout(function () {
                    $('#wrong').addClass("d-none");
                    getProb(operation);
                }, 3000);
            }
        }
    }

    function playGame() {
        if (answers > 1) {
            $('#mathform').addClass("d-none");
            $("#formx").removeClass('d-none');
            $("#next").removeClass('d-none');
        } else if (answers === 1) {
            $('#mathform').addClass("d-none");
            $("#dogname").focus();
            $("#formx").removeClass('d-none');
        }
        if (sources[answers][2].length > 0) {
            audio.playAudioFile(sources[answers][2]);
        }

    }
    
    $("#myanswer").on("click", function () {
        answerit();
    });

    //  ADDS event to name me button ;
    $("#buttonh").on("click", function () {
        //BlurActiveElement();
        $("#formx").addClass('d-none');
        $(".pet_name").remove();
        getProb();
    });

    // GETS A PROBLEM WHEN THEY CLICK ON THE NEXT BUTTON
    $("#next").on("click", function () {
        if (answers !== num_problems) {
            getProb();
        } else {
            window.location.href = options.completionURL;
        }

    });

    // SHOWS A PROBLEM ;
    getProb();
});

export {setConfig};