import $ from "./jquery.module.js";
import SetConfig from "./set_config_class.js";
import {getBadgeState, clearAllBadges} from "./badges.js";
import {clearAchievements} from "./achievements.js";
import {langSwitch} from "./language.js";

let setConfigHandler = new SetConfig();
let menuDisplayItems = {};
let badgeState = getBadgeState();
let menuConfig = null;


function setConfig(config) {
    setConfigHandler.setConfig(config);
}

function addMenuConfigItems(config) {
    let menu_items = config.menu_items;
    let row1 = menu_items[0];


    let $row1 = $("#row1");
    for (const menuItem of row1) {
        let menuID = menuItem.menuID;
        let img = `<img class="menu-img" alt = "${menuItem.alt}" src="${menuItem.imagePath}">`;
        let $itemDiv = $(`<div  class="menu-item">${img}<div>`);

        $row1.append($itemDiv);
        $itemDiv.on("click", () => window.location.href = menuItem.url);
        menuDisplayItems[menuID] = {div: $itemDiv};
    }
   if(menu_items[1])  {
       let row2 = menu_items[1];
       let $row2 = $("#row2");
       for (const menuItem of row2) {
           let menuID = menuItem.menuID;
           let img = `<img class="menu-img" alt = "${menuItem.alt}"  src="${menuItem.imagePath}">`;
           let $itemDiv = $(`<div  class="menu-item">${img}<div>`);
           $row2.append($itemDiv);
           $itemDiv.on("click", () => window.location.href = menuItem.url);
           menuDisplayItems[menuID] = {div: $itemDiv};
       }
       $(".menu-row").removeClass("menu-row").addClass("menu-row2");
   }
   else {
       $row1.removeClass("menu-row2").addClass("menu-row") ;
   }


}

function displayBadges(config) {
    let badges = config.options?.badges;
    if (!badges) {
        return;
    }
    for (let menuID in badgeState) {
        if (!(menuID in menuDisplayItems)) {
            continue;
        }
        let $menuDisplayItemDiv = menuDisplayItems[menuID].div;
        let $badgeContainer = $menuDisplayItemDiv.find(".badge-container");
        if ($badgeContainer.length === 0) {
            $badgeContainer = $(`<div class="badge-container"></div>`);
            $menuDisplayItemDiv.append($badgeContainer);
        }

        $badgeContainer.html("");  // Remove previous displayed badges
        if (badgeState[menuID].count > 0) {
            let badge =  badges[badgeState[menuID].badge];
            let icon = badge.icon;
            let style = badge.class;
            $badgeContainer.append(`<img src="${icon}" class="${style}" alt="badge">`);
        }

    }
}

function initializeBadges() {
    clearAchievements();
    clearAllBadges();
    window.location.reload();
}

$(() => {
    setConfigHandler.then((config) => {
        menuConfig = config;
        badgeState = config?.testBadgeState ?? badgeState;
        addMenuConfigItems(config);
        $("#wrapper").css("background-image","url(" + config.options.bkImage +")") ;
        $("#menu_title").html(config.options.title) ;
        displayBadges(config);
        $("#testClearBadges").on("click", initializeBadges);
    });
});

export {setConfig};