// toolbar.js
// module

import * as config from "./toolbar_config.js";
import * as home from "./home.js";
import * as gamestate from "./gamestate.js";
import * as db from "./database_access.js";
import $ from "./jquery.module.js";

function addButtons() {
    let rootURL = home.homeDirectory();

    if (typeof(config.hub1) !== "undefined" && !window.location.pathname.endsWith(config.hub1.url)) {
        let hub = config.hub1;
        let hub_button = `<img class="${hub.class}" src="${rootURL}${hub.icon}" alt="${hub.name}" />`;
        appendElementToToolbar(hub_button);
        $(`.${hub.class}`).click(() => db.safe_go_to(`${rootURL}${hub.url}`));
    }
    if (typeof(config.hub2) !== "undefined" && !window.location.pathname.endsWith(config.hub2.url)) {
        let hub = config.hub2;
        let hub_button = `<img class="${hub.class}" src="${rootURL}${hub.icon}" alt="${hub.name}" />`;
        appendElementToToolbar(hub_button);
        $(`.${hub.class}`).click(() => db.safe_go_to(`${rootURL}${hub.url}`));
    }
}

function addPoints() {
    let points = gamestate.points();
    let points_element = `<span class="${config.points_class}">${points}</span>`;
    appendElementToToolbar(points_element);
    gamestate.addPointHandler((h) => {$("." + config.points_class).text(gamestate.points().toString());});
}

function appendElementToToolbar(e) {
    let theDiv = config?.toolbar_id;
    if (!theDiv || $(theDiv).length === 0) {
        theDiv = config.container_id;
    }
    $(theDiv).append(e);
}

$(() => {
    addButtons();
    addPoints();
});